from Algorithms.Utility.non_dominated_sort import non_dominated_sort
import numpy as np

import config as cg

def create_parent_population(pop, eng):
    """ Return a parent population with higest HV indicator """
    P                    = []
    N                    = cg.pop_size
    bounds               = cg.reference

    # Non-domination Sorting, pop = parents + offsprings
    non_dominated_fronts = non_dominated_sort(pop)

    # Select the first non-dominted fronts
    for P1 in non_dominated_fronts:
        if len(P) + len(P1) > N:
            break
        P += P1

    # The number of overflow of solutions
    k = len(P) + len(P1) - N

    # Remove Solutions With Lowest Hypervolume (HV) Indicator
    while k > 0:
        # Calulcate HV indicator
        objectives = [P1[i].fitness.values for i in range(len(P1))]
        f = eng.hypeIndicatorExact(np.array(objectives).T.tolist(), bounds, k)

        # Remove the solution with lowest HV indicator
        i = np.argmin(f)
        del P1[i]
        k -= 1

    # Return parent population with size N
    return P + P1
