from Algorithms.HypE.create_parent_population import create_parent_population
from Algorithms.HypE.binary_tournament_selection import binary_tournament_selection

from Algorithms.Utility.eval_objective_values import eval_objective_values
from Algorithms.Utility.mate import mate
from Algorithms.Utility import logData

import config as cg
import numpy as np

def mating_selection(population, chrom_repr, toolbox, eng, cx, mx):
    objectives = [population[i].fitness.values for i in range(len(population))]
    hype_indicator = eng.hypeIndicatorExact(np.array(objectives).T.tolist(), cg.reference, cg.pop_size)

    for ind, rank in zip(population, hype_indicator[0]):
        ind.rank = rank
    offspring = mate(population, toolbox, binary_tournament_selection, chrom_repr, cg.pop_size, cx, mx)
    return offspring

def environmental_selection(population, eng):
    population = create_parent_population(population, eng)
    return population

def init_population(loggerObj, toolbox, L_BOUND, U_BOUND, eng, motion, with_omega):

    population, n_gen = logData.start_from_temporary_save(loggerObj, toolbox)

    for i in range(len(population)):
        population[i].Low = L_BOUND
        population[i].Upp = U_BOUND

    sim_time = eval_objective_values(population, eng, motion, with_omega)

    return population, n_gen, sim_time

if __name__ == "__main__":
    pass
    input("Press Enter to continue...")
