import numpy as np
import config as cg

def non_dominated_sort(pop):

    N = len(pop)

    n_obj = cg.n_objectives + 1

    container     = [];
    front         = [];

    for i in range(N):
        u = pop[i]
        obj1 = np.array(u.fitness.values)
        container += [{'set': [], 'count': 0}]
        for j in range(N):
            v = pop[j]
            obj2 = np.array(v.fitness.values)
            if np.all((obj1 <= obj2) & np.any(obj1 < obj2)):
                container[i]['set'] += [j]
            elif np.all((obj2 <= obj1) & np.any(obj2 < obj1)):
                container[i]['count'] += 1
        if container[i]['count'] == 0:
            front += [u]

    return front
