import numpy as np
import config as cg
from Algorithms.NSGA2.crowding_distance import crowding_distance

def create_parent_population(fronts):

    pop_size        = cg.pop_size
    P_pop           = []
    P_viol          = []
    container       = []
    n_fronts        = len(fronts)

    # Assign non-violent and violent fronts in different containers
    for i in range(n_fronts):
        temp_container  = [[],[]]
        for j in range(len(fronts[i])):
            # violations = fronts[i][j].violations
                # for k in range(len(fronts[i][j].fitness.values)-cg.n_objectives)]
            if fronts[i][j].violations[0] == np.double(0):
                temp_container[0]    += [fronts[i][j]]
                # print("YAAAAH!")
            else:
                temp_container[1]    += [fronts[i][j]]
        container += [temp_container]

    for i in range(2):
        k = np.uint32(0)
        while k < n_fronts and len(container[k][i]) != 0 and len(P_pop) < pop_size:
            crowd_front = crowding_distance(container[k][i])
            dist = [crowd_front[q].crowd_dist for q in range(len(crowd_front))]
            j = np.argsort(dist)
            k += 1
            for r in j[::-1]:
                crowd_front[r].rank = k
                P_pop += [crowd_front[r]]
                if len(P_pop) >= pop_size:
                    break

    return P_pop
