from Algorithms.NSGA2.crowding_distance import crowding_distance

import numpy as np
import config as cg

def create_parent_population(fronts):

    pop_size  = cg.pop_size
    P         = []
    container = []
    n_fronts  = len(fronts)

    # Assign non-violent and violent fronts in different containers
    for i in range(n_fronts):
        temp_container  = [[],[]]
        for j in range(len(fronts[i])):
            # Place Feasible Solutions In Container 0
            if fronts[i][j].violations[0] == np.double(0):
                temp_container[0]    += [fronts[i][j]]
            # Place Infeasible Solutions In Container 1
            else:
                temp_container[1]    += [fronts[i][j]]
        container += [temp_container]

    # Assign Crowding Distance. Consider Feasible Solutions First!
    for i in range(2):
        k = np.uint32(0)
        while k < n_fronts and len(container[k][i]) != 0 and len(P) < pop_size:
            crowd_front = crowding_distance(container[k][i])
            dist = [crowd_front[q].crowd_dist for q in range(len(crowd_front))]
            j = np.argsort(dist)
            k += 1
            for r in j[::-1]:
                crowd_front[r].rank = k
                P += [crowd_front[r]]
                if len(P) >= pop_size:
                    break
    return P
