import numpy as np
import config as cg

def crowding_distance(front):
    n_row = len(front)
    fitness = []

    for i in range(n_row):
        front[i].crowd_dist = np.double(0.0)

    for k in range(cg.n_objectives):
        # Get objective values
        fitness = [front[i].fitness.values[k] for i in range(n_row)]

        # Sort Pareto front
        sorted_index = np.argsort(fitness)
        front = [front[i] for i in sorted_index]

        # Assign crowding ditance with inf at the edges
        front[0].crowd_dist         = np.inf
        front[n_row-1].crowd_dist   = np.inf

        # Get min and max objective values
        obj_min = fitness[sorted_index[0]]
        obj_max = fitness[sorted_index[n_row-1]]

        # Assign crowding distances in the Pareto front
        for i in range(1,n_row-1):
            dist = (front[i+1].fitness.values[k] - front[i-1].fitness.values[k]) / np.double(obj_max - obj_min)
            if not np.isnan(dist):
                front[i].crowd_dist = front[i].crowd_dist + dist

    return front
