from Algorithms.NSGA2.binary_tournament_selection import binary_tournament_selection
from Algorithms.NSGA2.create_parent_population import create_parent_population

from Algorithms.Utility.eval_objective_values import eval_objective_values
from Algorithms.Utility.non_dominated_sort import non_dominated_sort
from Algorithms.Utility.mate import mate
from Algorithms.Utility import logData

import config as cg

def mating_selection(population, chrom_repr, toolbox, eng, cx, mx):
    offspring   = mate(population, toolbox, binary_tournament_selection, chrom_repr, cg.pop_size, cx, mx)
    return offspring

def environmental_selection(population, eng):
    front       =  non_dominated_sort(population)
    population  = create_parent_population(front)
    return population

def init_population(loggerObj, toolbox, L_BOUND, U_BOUND, eng, motion, with_omega):

    population, n_gen = logData.start_from_temporary_save(loggerObj, toolbox)

    for i in range(len(population)):
        population[i].Low = L_BOUND
        population[i].Upp = U_BOUND

    sim_time = eval_objective_values(population, eng, motion, with_omega)
    front =  non_dominated_sort(population, ranking=True)

    return population, n_gen, sim_time

if __name__ == "__main__":
    pass
    input("Press Enter to continue...")
