import numpy as np
import random
import config as cg

def bit_flip_mutation(ind, chrom_repr, nr_flips):
    # print("========= Before mutation ===========")
    # print(ind)
    for i in range(1, nr_flips):
        nr_of_genes = len(chrom_repr)
        chrom_size  = np.sum(chrom_repr)
        flip_bit = np.random.randint(0,high=chrom_size)

        nr_of_bits = 0
        for gene,i in zip(chrom_repr,range(nr_of_genes)):
            if flip_bit-nr_of_bits < gene and flip_bit-nr_of_bits >= 0:
                bit_mask = np.uint32(np.left_shift(1,flip_bit-nr_of_bits))
                if np.bitwise_and(ind[i],bit_mask) > 0:
                    ind[i] = np.bitwise_and(ind[i], np.invert(bit_mask))
                else:
                    ind[i] = np.bitwise_or(ind[i], bit_mask)
                break
            nr_of_bits += gene

    # print("========= After mutation ===========")
    # print(ind)

    return ind
