from Algorithms.Utility.decode_ind import decode_ind
import numpy as np

def eval_objective_values(pop, eng, motion, with_omega):
    gait = np.array(list(map(decode_ind(motion, with_omega), pop))).T.tolist()
    objectives, violations, sim_time = eng.objective_function_evaluation(gait, motion, with_omega, nargout=3)

    # print(violations)

    if len(pop) == 1:
        # print(objectives)
        pop[0].fitness.values = objectives[0]
        pop[0].violations = violations
    else:
        for ind, obj, viol in zip(pop, objectives, violations):
            ind.fitness.values = obj
            ind.violations     = viol

    return sim_time
