import config as cg
import numpy as np

def multi_point_crossover_set(ind1, ind2, chrom_repr, n):

    # if np.random.rand() <= cg.crossover_rate:

    nr_of_genes = len(chrom_repr)
    child1 = [0]*nr_of_genes
    child2 = [0]*nr_of_genes

    chrom_size  = np.sum(chrom_repr)
    crossover_points = np.arange(chrom_size);

    n_point = 2*n
    points = [0]*n_point

    for i in range(n_point):
        index = np.random.randint(0,high=crossover_points.size)
        points[i] = crossover_points[index]
        crossover_points = np.delete(crossover_points, index)

    points = sorted(points)

    for p1,p2 in zip(points[0::2],points[1::2]):

        start_point = p1
        end_point   = p2

        last = False
        do_cross = False
        current_bits = 0

        # print('###################################################')
        # print('start_point: ', start_point)
        # print('end_point: ', end_point)

        for gene,i in zip(chrom_repr,range(nr_of_genes)):
            point1 = start_point - current_bits

            if point1 < 0:
                point1 = 0

            if point1 < gene and end_point > (current_bits + gene-1):
                point2 = gene-1
                do_cross = True

            elif (end_point-current_bits) < gene:
                point2      = end_point-current_bits
                do_cross    = True
                last        = True

            if do_cross:
                # print('----------------------(',i+1,')------------------------')
                # print('point1: ', point1)
                # print('point2: ', point2)
                bit_mask         = np.uint32(np.power(2,point2-(point1-1)) - 1)
                bit_mask         = np.uint32(np.left_shift(bit_mask, point1))
                bit_mask_cmp     = np.uint32(np.invert(bit_mask))

                # print("The binary representation of the bitmask: ")
                # print(np.binary_repr(bit_mask,width=gene))

                child1[i] = np.bitwise_or(np.bitwise_and(ind1[i],bit_mask_cmp),\
                                        np.bitwise_and(ind2[i],bit_mask))
                child2[i] = np.bitwise_or(np.bitwise_and(ind2[i],bit_mask_cmp),\
                                        np.bitwise_and(ind1[i],bit_mask))
                ind1[i] = child1[i]
                ind2[i] = child2[i]

                if last:
                    break
                do_cross = False

            current_bits += gene
        # print(child1)
        # print(child2)

    return ind1, ind2
