import numpy as np
import config as cg

def non_dominated_sort(pop, ranking = False):

    N = len(pop)

    n_obj = cg.n_objectives + 1

    container     = [];
    current_front = [];
    front         = [[]];
    H             = ['None empty']

    for i in range(N):
        u = pop[i]
        obj1 = np.array(u.fitness.values)
        container += [{'set': [], 'count': 0}]
        for j in range(N):
            v = pop[j]
            obj2 = np.array(v.fitness.values)
            if np.all((obj1 <= obj2) & np.any(obj1 < obj2)):
                container[i]['set'] += [j]
            elif np.all((obj2 <= obj1) & np.any(obj2 < obj1)):
                container[i]['count'] += 1
        if container[i]['count'] == 0:
            current_front += [i]
            front[0] += [u]
            if ranking:
                pop[i].rank = 1

    while len(H) > 0:
        H = []
        next_front = []
        for i in current_front:
            for j in container[i]['set']:
                container[j]['count'] -= 1
                if container[j]['count'] == 0:
                    H += [pop[j]]
                    next_front += [j]
                    if ranking:
                        pop[j].rank = len(front) + 1
        front += [H]
        current_front = next_front

    return front
