import time
import numpy as np

def print_elapsed_time(elapsed_time, gen_time, sim_time, elapsed_computational_time, estimated_time, gen, n_gen):

    t1 = time_to_text(sim_time)
    t2 = time_to_text(gen_time - sim_time)
    t3 = time_to_text(elapsed_computational_time)
    t4 = time_to_text(elapsed_time)

    if len(estimated_time) == 10:
        del estimated_time[0]
        estimated_time += [gen_time]
    else:
        estimated_time += [gen_time]

    t5 = time_to_text( elapsed_time + (np.sum(estimated_time)/len(estimated_time))*(n_gen-gen) )

    print("Elapsed simulation time    :" + t1)
    print("Elapsed computational time :" + t2)
    print("\nTotal computational time   :" + t3)
    print("Total run time             :" +  t4)
    print("Estimated run time         :" + t5)

    return estimated_time

def convert_to_h_m_s(seconds):
    m, s = divmod(seconds, 60)
    h, m = divmod(m, 60)
    return h,m,s

def time_to_text(seconds):
    h, m, s = convert_to_h_m_s(seconds)
    if h > 0:
        if m > 0:
            time_text = "%d hours %d minutes and %.4f seconds" % (h,m,s)
        else:
            time_text = "%d hours and %.4f seconds" % (h,s)
    elif m > 0:
         time_text = "%d minutes and %.4f seconds" % (m,s)
    else:
         time_text = "%.4f seconds" % s

    return time_text
