close all

label_font_size = 14;
figpos = [972   483   603   387]; % Avhandling


% Plot Center of Mass position X
window = figure(1);
set(window, 'color', 'white');
plot(t,p_CM(:,1),'linewidth', 2)
grid on
xlabel('Time [sec]','FontSize',label_font_size);
ylabel('p_x [m]','FontSize',label_font_size);
set(gcf,'Position',figpos)

% Plot Center of Mass position Y
window = figure(2);
set(window, 'color', 'white');
plot(t,p_CM(:,2),'linewidth', 2)
grid on
xlabel('Time [sec]','FontSize',label_font_size);
ylabel('p_y [m]','FontSize',label_font_size);
set(gcf,'Position',figpos)

% Plot Path X-Y

window = figure(3);
set(window, 'color', 'white');
plot(p_CM(:,1), p_CM(:,2), 'linewidth', 2)
hold on
plot([p_CM(1,1) p_CM(end,1)], [0 0], 'r--','linewidth', 2)
grid on
hold off
xlabel('p_x [m]','FontSize',label_font_size);
ylabel('p_y [m]','FontSize',label_font_size);
ylim([-2 1])
h = legend('Path of CM of robot', 'Reference path', 'location', 'northeast');
set(h,'fontsize',14,'interpreter','latex');
set(gcf,'Position',figpos)
legend('boxoff')


% Plot Orientation
window = figure(4);
set(window, 'color', 'white');
plot(t, theta_av*180/pi,'linewidth', 2)
xlabel('Time [sec]','FontSize',label_font_size);
ylabel('$\overline{\theta}$ [deg]','FontSize',label_font_size,'interpreter','latex')
set(h,'fontsize',14,'interpreter','latex');
set(gcf,'Position',figpos)

% Plot Forward Velocity
window = figure(5);
set(window, 'color', 'white');
plot(t,speed,'linewidth', 2)
grid on
xlabel('Time [sec]','FontSize',label_font_size);
ylabel('$\overline{v}_t$ [m/s]','FontSize',16,'interpreter','latex');
set(gcf,'Position',figpos)
