function u_bar = calculate_u_eel(t, phi, phi_dot,...
                            alpha, omega, delta, g_scale, four_coeff,...
                                        n, Kp_joint, Kd_joint, u_max)

gamma = 0;

% Calculates references for joint coordinates.
phi_ref = zeros(n-1, 1);
for i = 1:n-1
    phi_ref(i, 1) = alpha*(n-i)/(n-1)*sin(omega*t + (i-1)*delta) + gamma;
end
% Calculates references for joint velocities.
phi_ref_d = zeros(n-1, 1);
for i = 1:n-1
    phi_ref_d(i, 1) = alpha*(n-i)/(n-1)*omega*cos(omega*t + (i-1)*delta);
end
% Calculates references for joint accelerations.
phi_ref_dd = zeros(n-1, 1);
for i = 1:n-1
    phi_ref_dd(i, 1) = -alpha*(n-i)/(n-1)*omega^2*sin(omega*t + (i-1)*delta);
end

%Calculates the actuator forces.
u_bar = zeros(n-1, 1);
for i = 1:n-1
    error = phi_ref(i, 1) - phi(i, 1);
    error_d = phi_ref_d(i, 1) - phi_dot(i, 1);
    %u(i, 1) = Kp_joint*error - Kd_joint*phi_dot(i, 1);
    u_bar(i, 1) = phi_ref_dd(i, 1) + Kd_joint*error_d + Kp_joint*error;
end

%Saturation of the input torque
if 1
    u_bar = min(u_bar, u_max);
    u_bar = max(u_bar, -u_max);
end