function u_bar = calculate_u_fourier(t, phi, phi_dot,...
                            alpha, omega, delta, g_scale, four_coeff,...
                                        n, Kp_joint, Kd_joint, u_max)

% gamma = 0;

% a0      = four_coeff(1);
% a       = four_coeff(2:ceil(end/2));
% b       = four_coeff(ceil(end/2)+1:end);
% n_order = 1:numel(four_coeff(2:end))/2;

% If you don't include a0
a       = four_coeff(1:ceil(end/2));
b       = four_coeff(ceil(end/2)+1:end);
n_order = 1:(numel(four_coeff))/2;

% disp(numel(n_order))
% f1      = @(n,t,offset)(cos(n*t + offset));
% f2      = @(n,t,offset)(sin(n*t + offset));

L       = numel(n_order)/omega;
f1      = @(n,t,offset)(cos((n/L)*t + offset));
f2      = @(n,t,offset)(sin((n/L)*t + offset));

% Calculates references for joint coordinates.
phi_ref = zeros(n-1, 1);
for i = 1:n-1
%     phi_ref(i, 1) = a0 + sum(a.*f1(n_order,t,(i-1)*delta) + b.*f2(n_order,t,(i-1)*delta));
%     phi_ref(i, 1) = sum(a.*f1(n_order,t,(i-1)*delta) + b.*f2(n_order,t,(i-1)*delta));
%     phi_ref(i, 1) = a0 + sum(a.*f1(n_order,t,(i-1)*delta) + b.*f2(n_order,t,(i-1)*delta));
    phi_ref(i, 1) = sum(a.*f1(n_order,t,(i-1)*delta) + b.*f2(n_order,t,(i-1)*delta));
end
% Calculates references for joint velocities.
phi_ref_d = zeros(n-1, 1);
for i = 1:n-1
    phi_ref_d(i, 1) = sum((n_order/L).*a.*(-f2(n_order,t,(i-1)*delta)) + (n_order/L).*b.*f1(n_order,t,(i-1)*delta));
end
% Calculates references for joint accelerations.
phi_ref_dd = zeros(n-1, 1);
for i = 1:n-1
    phi_ref_dd(i, 1) = sum(((n_order/L).^2).*a.*(-f1(n_order,t,(i-1)*delta)) + ((n_order/L).^2).*b.*(-f2(n_order,t,(i-1)*delta)));
end

%Calculates the actuator forces.
u_bar = zeros(n-1, 1);
for i = 1:n-1
    error = phi_ref(i, 1) - phi(i, 1);
    error_d = phi_ref_d(i, 1) - phi_dot(i, 1);
    %u(i, 1) = Kp_joint*error - Kd_joint*phi_dot(i, 1);
    u_bar(i, 1) = phi_ref_dd(i, 1) + Kd_joint*error_d + Kp_joint*error;
end

%Saturation of the input torque
if 1
    u_bar = min(u_bar, u_max);
    u_bar = max(u_bar, -u_max);
end