function z = calculate_z(p_CM, e, K, sin_theta_diag, cos_theta_diag)
%
% Calculates and returns the position of each link of the snake.
%

sin_theta = sin_theta_diag*e;
cos_theta = cos_theta_diag*e;


%=======================================================
% Position as a function of the CM position
%=======================================================

% Position of each link in the global x direction
x = -K'*cos_theta + e*p_CM(1, 1);

% Position of each link in the global y direction
y = -K'*sin_theta + e*p_CM(2, 1);

% Constructs the return vector
z = [x ; y];
