function z_dot = calculate_z_dot(theta_dot, p_CM_dot,sin_theta_diag, cos_theta_diag, e, K)
%
% Calculates and returns the linear velocity of each link of the snake.
%

%=======================================================
% Linear velocity as a function of the CM velocity
%=======================================================


% Linear velocities of each link in the global x direction
x_dot = K'*sin_theta_diag*theta_dot + e*p_CM_dot(1, 1);

% Linear velocities of each link in the global y direction
y_dot = -K'*cos_theta_diag*theta_dot + e*p_CM_dot(2, 1);


% Constructs the return vector
z_dot = [x_dot ; y_dot];