function [violated,isterminal,direction] = check_feasible_events(t, v)
    
    % Saturation of torque input
%     u_max=2.3*1000; %2.3Nm for Mamba joints
    % Saturation of angular speed
    phi_max=90*pi/180; %90 degrees
    % Saturation of angular speed
    phi_dot_max=429*pi/180; %429 degrees/sec    
    n_links = 10;
    
    violated = -1;
    isterminal = 1;
    direction = 0;
    
    % Extracts the states from the state vector
    theta               = v(1:n_links, 1);
    theta_dot           = v(n_links+3:2*n_links+2, 1);
    
    % Difference matrix
    D = [];
    for i = 1:n_links-1
        for j = 1:n_links
            if (i==j)
                D(i,j) =  1;
            elseif (i==j-1)
                D(i,j) = -1;
            end
        end
    end
    
    % Calculates the joint angles
    phi = D*theta;
    % Calculates the joint angle velocities
    phi_dot = D*theta_dot;
    
    for j = 1:n_links-1
        if -(phi(j) + phi_max) > 0
            violated = 0;
%             disp('EVENT1')
        elseif -(phi(j) + phi_max) > 0
            violated = 0;
%             disp('EVENT2')
        elseif -(phi_dot(j) + phi_dot_max) > 0
            violated = 0;
%             disp('EVENT3')
        % The upper bound of phi_dot
        elseif phi_dot(j)-phi_dot_max > 0
            violated = 0;
%             disp('EVENT4')
        end
    end
    
end