% Gait parameters
alpha = 37*pi/180;    %(rad/s) 
omega = 60*pi/180;    %(rad/s) 
delta = 2*pi/n;    %(rad/s) 
gamma = 0*pi/180;     %(rad/s)

% Calculates initial relative angles
phi0(1, 1) = -90*pi/180;
for i = 2:n
    phi0(i, 1) = alpha*sin((i-2)*delta);
end

% Calculates initial absolute joint angles
theta0 = inv([-1 zeros(1, n-1) ; D])*phi0;

% Initial position of the CM (center of mass) of each link
x0 = zeros(n, 1);
y0 = zeros(n, 1);
for i =1:n
    if i == 1
        x0(i) = 0.1;
        y0(i) = 0;
    else
        x0(i) = x0(i-1) + l_i(i-1)*cos(theta0(i-1)) + l_i(i)*cos(theta0(i));
        y0(i) = y0(i-1) + l_i(i-1)*sin(theta0(i-1)) + l_i(i)*sin(theta0(i));
    end
end

% Draws the initial position of the snake robot
drawSnakeRobot(theta0(:, 1), [x0 ; y0], p0, 0, [], 100);
