function [forward_speed, P_avg] = evaluate_mult_obj_func(pop_size, sim_data, n)

    forward_speed = [];
    P_avg         = [];
    
    %% Calculate the objective functions
    for i = 1:pop_size
        t               = sim_data(i).time;
        v               = sim_data(i).state_vector;
        p_CM            = v(:, n+1:n+2);
        P_joints_sim    = sim_data(i).P_joints;
    % ------- Calculate the forward speed for each individual ---------- 
        forward_speed(1,i) = sqrt(p_CM(end, 1)^2+p_CM(end, 2)^2)/t(end,1);     
    % ------------------------------------------------------------------
    % -- Calculate the Averaged Power Consumption for each individual --
        t_previous=0;
        for j=1:length(t)
            d_t(j) = t(j) - t_previous;
            Power_vector_temp(j) = P_joints_sim(j)*d_t(j);
            t_previous = t(j);
        end
        P_avg(1,i)=sum(Power_vector_temp)/t(end, 1);
    % ------------------------------------------------------------------
    end
end