function u_bar = calculate_u_multi_fourier(t, phi, phi_dot,...
                            alpha, omega, delta, g_scale, four_coeff,...
                                        n, Kp_joint, Kd_joint, u_max)

% gamma = 0;

% a0      = four_coeff(1);
% a       = four_coeff(2:ceil(end/2));
% b       = four_coeff(ceil(end/2)+1:end);
% n_order = 1:numel(four_coeff(2:end))/2;

% If you don't include a0
a       = four_coeff(1:ceil(end/2));
b       = four_coeff(ceil(end/2)+1:end);

n_coeff = numel(four_coeff)/((n-1)*2);
n_order = 1:(n_coeff);

% disp(four_coeff)
% disp("================================")
% disp(int16(omega*(180/pi)))

L       = numel(n_order)/omega;
% f1      = @(m,t)(cos((m/L)*t));
% f2      = @(m,t)(sin((m/L)*t));

f1      = @(m,t,offset)(cos((m/L)*t + offset));
f2      = @(m,t,offset)(sin((m/L)*t + offset));


% Calculates references for joint coordinates.
phi_ref = zeros(n-1, 1);
for i = 1:n-1
    phi_ref(i, 1) = sum(a(1+(i-1)*n_coeff:i*n_coeff).*f1(n_order,t,(i-1)*delta) + b(1+(i-1)*n_coeff:i*n_coeff).*f2(n_order,t,(i-1)*delta));
end
% Calculates references for joint velocities.
phi_ref_d = zeros(n-1, 1);
for i = 1:n-1
    phi_ref_d(i, 1) = sum((n_order/L).*a(1+(i-1)*n_coeff:i*n_coeff).*(-f2(n_order,t,(i-1)*delta)) + (n_order/L).*b(1+(i-1)*n_coeff:i*n_coeff).*f1(n_order,t,(i-1)*delta));
end
% Calculates references for joint accelerations.
phi_ref_dd = zeros(n-1, 1);
for i = 1:n-1
    phi_ref_dd(i, 1) = sum(((n_order/L).^2).*a(1+(i-1)*n_coeff:i*n_coeff).*(-f1(n_order,t,(i-1)*delta)) + ((n_order/L).^2).*b(1+(i-1)*n_coeff:i*n_coeff).*(-f2(n_order,t,(i-1)*delta)));
end

%Calculates the actuator forces.
u_bar = zeros(n-1, 1);
for i = 1:n-1
    error = phi_ref(i, 1) - phi(i, 1);
    error_d = phi_ref_d(i, 1) - phi_dot(i, 1);
    %u(i, 1) = Kp_joint*error - Kd_joint*phi_dot(i, 1);
    u_bar(i, 1) = phi_ref_dd(i, 1) + Kd_joint*error_d + Kp_joint*error;
end

%Saturation of the input torque
if 1
    u_bar = min(u_bar, u_max);
    u_bar = max(u_bar, -u_max);
end