function plot_objectives(obj1, obj2, gen, method, motion)

    figure(70)
    % Plot objectives
    scatter(cell2mat(obj1)',-cell2mat(obj2)');
    
    % Title
    title_text = sprintf("Generation: %d", int16(gen));
    title(title_text)
    
    % Labels
    xlabel('$P_{avg}$ [W]','FontSize',14,'interpreter','latex');
    ylabel('$\bar{\upsilon}$ [m/s]','FontSize',14,'interpreter','latex');
        
    % Legend
    le = legend(['Algorithm: ', method, ', Motion: ', motion], 'Location', 'se');
    set(le,'FontSize',12,'interpreter','latex')
    
    % Figure position
    figpos = [972   483   603   387];
    set(gcf,'Position',figpos)
    grid on
end
