import matlab.engine
import numpy as np
import array
import os

import load_utility as load

def clear_information(info_file):
    with open(info_file, 'w') as fp:
        fp.write('')
    fp.close()

def json_to_mat(result_file, result_info, matlab_info, directory):
    print("## Connecting to MATLAB engine...")

    eng = matlab.engine.start_matlab()
    os.system('cls')
    return_path = os.getcwd()
    ###########################################################################
    if not os.path.exists(directory+"/mat_files"):
        os.makedirs(directory+"/mat_files")
    os.chdir(directory+"/mat_files")
    # Clear matlab_info.txt file
    clear_information(matlab_info)
    os.chdir("..")
    ###########################################################################
    data = load.json_file(result_file)
    keys, n_data = load.info_file(result_info)
    ###########################################################################
    os.chdir(return_path)
    ###########################################################################
    # cx = ["cross0.4", "cross0.55", "cross0.7", "cross0.85"]
    print("Converting .json files to .mat files...")
    for key in keys:
        pop = data[key[0]][key[1]][key[2]][key[3]][key[4]][key[5]]["population"]
        obj = data[key[0]][key[1]][key[2]][key[3]][key[4]][key[5]]["objectives"]
        eng.json_to_matlab(pop,obj,key[0],key[1],key[2],key[3],key[4],key[5],directory+"/mat_files",nargout=0)

    print("======================== End Of Execution ========================")
    input("Press Enter to continue...")

if __name__ == "__main__":
    # convert_data_to_matlab("mergedData.json", "mergedInfo.txt", "../All")
    json_to_mat("pop.json", "popInfo.txt", "pop_info.txt", "../extended_model")
