% function data_to_workspace(pop, obj, name)
% function data_to_workspace(pop,obj,name,method,motion,pop, gen, cross, mut)
function json_to_matlab(pop,obj,method,motion,n_pop,n_gen, cross, mut, dir)

%     directory = sprintf('../%s',dir);
    return_path = pwd;
    cd(dir)

    population = {};
    pop_gen = {};
    for data = 1:numel(pop)
        for gen = 1:numel(pop{data})
            pop_temp = [];
            for ind = 1:numel(pop{data}{gen})
                pop_temp = [pop_temp; cell2mat(pop{data}{gen}{ind})];
            end
            pop_gen{gen} = pop_temp;
        end
        population{data} = pop_gen;
    end

    objectives = {};
    obj_gen    = {};
    for data = 1:numel(obj)
        for gen = 1:numel(obj{data})
            obj_temp = [];
            for ind = 1:numel(obj{data}{gen})
                obj_temp = [obj_temp; cell2mat(obj{data}{gen}{ind})];
            end
            obj_gen{gen} = obj_temp;
        end
        objectives{data} = obj_gen;
    end

%     if numel(char(cross)) == 8
%         cross = cross + "0";
%     end
% 
%     if numel(char(mut)) == 6
%         mut = mut + "0";
%     end

%     data = struct('population', population, 'objectives', objectives);
    file_name =  [method,'_',motion,'_',n_pop,'_',n_gen,'_',cross,'_',mut];
    file_name = char(file_name);

    index = strfind(file_name,'-');
    file_name(index) = '';

    index = strfind(file_name,'.');
    file_name(index) = '';

    disp(file_name)
    save([file_name,'.mat'], 'population', 'objectives')

    % Update matlab_info.txt file (keeps the name of all the .mat files)
    info = regexp( fileread('matlab_info.txt'), '\n', 'split');
    info{end} = sprintf('%s',file_name);
    fid = fopen('matlab_info.txt', 'w');
    fprintf(fid, "%s\n", info{:});
    fclose(fid);

    cd(return_path)

end
