import ast
import gzip
import json

def gz_file(readfile):
    print("Loading gz-file...")
    with gzip.open(readfile, 'rb') as f:
        data = f.read()
    f.close()
    print("Done loading!\n")
    print("Decode binary text to dictionary objects...")
    data = data.decode('ascii')
    data  = ast.literal_eval(data)
    print("Conversion done!")
    return data

def json_file(readfile):
    print("Loading json-file...")
    with open(readfile) as fp:
        data = json.loads(fp.read())
    fp.close()
    print("Done loading!")
    return data

def info_file(result_info):
    keys = []
    nr_of_data = []
    with  open(result_info, 'r+') as fp:
        for line in fp:
            index1 = 0
            index2 = 0
            key = []
            nr_of_data += [int(line[:line.find(':')])]
            while index1 < len(line) and index2 < len(line):
                index1 = line.find(' ', index1)
                index2 = line.find(',', index2)
                if index1 == -1 or index2 == -1:
                    break
                key += [line[index1+1:index2]]
                index1 += 1
                index2 += 1
            key += [line[index1+1:len(line)-1]]
            keys += [key]
    fp.close()
    return keys, nr_of_data
