import load_utility as load
import write_utility as write

import numpy as np
import os

def init_dict(data, keys):

    for i in range(len(keys)):
        it = data
        for key in keys[i]:
            if key in it:
                it = it[key]
            else:
                it[key] = {}
                it = it[key]
    return data

def update_information(data, keys, outputfile):
    infoText = ''
    for key in keys:
        it = data[key[0]]
        for i in range(1,len(key)):
            it = it[key[i]]
        n_data = len(it["objectives"])
        infoText += "%d: " % n_data + key[0] + ", " + key[1] + ", " + key[2] + \
                        ", " + key[3] + ", " + key[4] + ", " + key[5] + '\n'

    with open(outputfile, 'w') as fp:
        fp.write(infoText)
    fp.close()

def rename(directory, input_file, info_file, output_file, output_info):
    os.chdir(directory)

    print("\n## Result json-file 1:")
    data = load.json_file(input_file)

    keys, n_data = load.info_file(info_file)
    new_keys = [key[:] for key in keys];
    new_key = "Lateral"

    for i in range(len(keys)):
        for k in range(len(keys[i])):
            if keys[i][k] == "Undulation":
                new_keys[i][k] = new_key

    new_dict = init_dict({}, new_keys)

    for i in range(len(keys)):
        # key_exist = False
        it      = new_dict[keys[i][0]]
        result = data[keys[i][0]]

        for k in range(1,len(keys[i])):
            if keys[i][k] != new_keys[i][k]:
                it = it[new_keys[i][k]]
            else:
                it      = it[keys[i][k]]
            result = result[keys[i][k]]

        it["population"] = result["population"]
        it["objectives"] = result["objectives"]

    write.gz_file(new_dict, output_file)
    update_information(new_dict, new_keys, output_info)

if __name__ == "__main__":
    rename("../All","resultData2.json", "resultInfo2.txt", "output_file.json", "output_info.txt")
