function plot_selected(data, pop, cross, mut)
    %     figure(45)
    % Plot objectives
    a = 0;
    while a ~= -1
        fprintf('\n');
        disp('==================================');
        fprintf('##\t Select Population Size:\n');
        disp(pop);
        pop_index = select_menu(pop);
        disp('==================================');
        fprintf('##\t Select Crossover Rate:\n');
        disp(cross);
        cross_index = select_menu(cross);
        disp('==================================');
        fprintf('##\t Select Mutation Rate:\n');
        disp(mut)
        mut_index = select_menu(mut);  
        
        selected_data = data{pop_index}{cross_index}{mut_index};
        
        disp('==================================');
        fprintf('##\t Select Sample:\n');
        sample_index = select_menu(selected_data.objectives);
        disp('==================================');
        fprintf('##\t Select Generation:\n');
        gen_index = select_menu(selected_data.objectives{sample_index});
        
        P_avg = selected_data.objectives{sample_index}{gen_index}(:,1);
        v_forward = -selected_data.objectives{sample_index}{gen_index}(:,2);
        
        plot_result(P_avg, v_forward, pop{pop_index}, gen_index, cross{cross_index}, mut{mut_index})
        
        disp('==================================');
        fprintf('##\t Done?:\n');        
        a = int16(input('Yes[-1]|Reset[0]:\n'));
        
        if a == 0
           clf('reset') 
        end
    end    
    
    function plot_result(P_avg, v_forward, pop, gen_nr, crossover, mutation)
        figure(56);
        hold on
        scatter(P_avg, v_forward, 60, '.','DisplayName',pop + ", " + crossover+ ", " + mutation)  
        % Title
        title_text = sprintf("Generation: %d", gen_nr-1);
        title(title_text)

        % Labels
        xlabel('$P_{avg}$ [W]','FontSize',14,'interpreter','latex');
        ylabel('$\bar{\upsilon}$ [m/s]','FontSize',14,'interpreter','latex');

        xlim([0,40]);
        ylim([0,1]);

        % Legend
%         le = legend(['Algorithm: ', moea, ', Motion: ', motion], 'Location', 'se');
%         set(le,'FontSize',12,'interpreter','latex')
        le = legend('Location', 'se');
        set(le,'FontSize',12,'interpreter','latex')
        legend('show')
        grid on
    end
    
    function index_selected = select_menu(arg)
        index_selected = 0;
        while isempty(index_selected) || ((index_selected > numel(arg)) || (index_selected < 1)) 
            text_input = sprintf('Select a nr. between 1-%d: ', numel(arg));
            index_selected = int16(input(text_input)); 
        end 
    end 
end